/* power - funkcija za stepenovanje - obuhvaceni i negativni izlozioci */
#include <stdio.h>

/* stepenuje x^k tako sto k puta pomnozi x */
float power(float x, unsigned n) {
  unsigned i;
  float s = 1.0;
  for (i = 0; i<n; i++)
    s*=x;
  return s;
}

/* Verzija koja radi i za negativne izlozioce */
float power_n(float x, int n) {
  unsigned i;
  int negative = n<0;

  if (negative)
    n = -n;

  float s = 1;
  for (i = 0; i < n; i++)
    s*=x;
    
  return negative ? 1.0/s : s;  
}

int main() {
  printf("%f\n", power(2.0, 8));
  printf("%f\n", power_n(2.0, -3));
  return 0;
}
